unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScardReader;

type
  TForm1 = class(TForm)
    SCardReader1: TSCardReader;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Button6: TButton;
    Edit2: TEdit;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);

    procedure SCardReader1ReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure SCardReader1ReaderActivate(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure SCardReader1ReaderSetMode(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure SCardReader1ReaderDeactivate(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure SCardReader1ReaderGetStatus(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure SCardReader1ReaderSendBlock(Sender: TObject;
      DataPtr: Pointer; DataSize: Integer);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);

  private
    { Private declarations }
    Command:String;
    CommandPosition: integer;
    function CommandString(s: String):String;
    procedure ToMemo1(s1, s2: String);

  public
    { Public declarations }

  end;

Const

//This is all the Command Mode for Reflex Reader,
//not support command is marked as Not Support
PC_to_RDR_GetRdrType    =$60;
PC_to_RDR_SetMode       =$61;
PC_to_RDR_CardPowerOn   =$62;
PC_to_RDR_CardPowerOff  =$63;
PC_to_RDR_Reset         =$64;
PC_to_RDR_GetRdrStatus  =$65;
PC_to_RDR_SendRdrByte   =$66;  //Not Support
PC_to_RDR_SendRdrBlock  =$67;
PC_to_RDR_ResendBlock   =$68;
PC_to_RDR_GetRdrCap     =$69;
PC_to_RDR_DeActivateRdr =$6A;
PC_to_RDR_Escape        =$6B; //Not Support

RDR_to_PC_Type          =$60;  //This is all the Return Mode for Reflex Reader
RDR_to_PC_Status        =$61;  //not all of them are used.
RDR_to_PC_Ack           =$62;  //
RDR_to_PC_DataByte      =$63;
RDR_to_PC_DataBlock     =$64;
RDR_to_PC_CardIn        =$65;
RDR_to_PC_CardOut       =$66;
RDR_to_PC_Nack          =$67;
RDR_to_PC_Cap           =$68;
RDR_to_PC_Escape        =$69;
RDR_to_PC_RFU           =$6F;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.CommandString(s: String):String;
var
  r,t: String;
  i,ti:integer;
begin
  r := '';
  s:=s+' ';
  t:='';
  for i :=1 to Length(s) do
  begin
    if s[i] <> ' ' then
      t:=t+s[i]
    else
    begin
      try
        ti:=StrToint(t);
        if ti>255 then
        begin
          result:='';
          Exit;
        end else
        begin
          r:=r+Char(ti);
        end;
      except
        result:='';
        Exit;
      end;
      t:='';
    end;
  end;
  result:=r;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SCardReader1.PCSC_DeActivateRdr;
  SCardReader1.DisConnect;
end;

procedure TForm1.ToMemo1(s1, s2: String);
var i:integer;
  t:String;
begin
  t:='';
  for i :=1 to Length(s2) do
    t:=t+' '+(intToStr(ord(s2[i])));
  t:=t+' [';
  for i :=1 to Length(s2) do
    t:=t+' '+intToHex(ord(s2[i]),2);
    t:=t+' ]';
  Memo1.Lines.Add(s1+' '+t);
end;

procedure TForm1.SCardReader1ReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Integer);

var p: pchar;
    s: string;
    i:integer;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Read Data:',s);
end;

procedure TForm1.SCardReader1ReaderActivate(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);
var p: pchar;
    s: string;
    i:integer;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Read On:',s);
end;

procedure TForm1.SCardReader1ReaderDeactivate(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);
var p: pchar;
    s: string;
    i:integer;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Reader Deactivate:',s);
  if length(s)=1 then if s[1]=char(RDR_to_PC_Ack) then
    Memo1.Lines.Add('Reader Off')
  else Memo1.Lines.Add('Unknown Error');
end;

procedure TForm1.SCardReader1ReaderSetMode(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);
var p: pchar;
    s: string;
    i:integer;
    b:byte;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Read Set Mode:',s);
  if length(s)=1 then if s[1]=char(RDR_to_PC_Ack) then
  begin
    if CommandPosition<Length(Command) then
    begin
      inc(CommandPosition);
      b:=ord(Command[CommandPosition]);
      ToMemo1('Read Set Byte:',char(b));
      SCardReader1.SendByte(b);
    end;
    if CommandPosition>=Length(Command) then
    begin
      CommandPosition:=0;
      Command:='';
    end;
  end;
end;

procedure TForm1.SCardReader1ReaderGetStatus(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);
var p: pchar;
    s: string;
    i:integer;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Reader Get Status:',s);
end;

procedure TForm1.SCardReader1ReaderSendBlock(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);
var p: pchar;
    s: string;
    i:integer;
begin
  s := '';
  p := DataPtr;
  for i :=0 to DataSize-1 do s:=s+p[i];
  ToMemo1('Reader Send Data Block:',s);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//PC_to_RDR_GetRdrType    =$60;
  SCardReader1.Connect;
  SCardReader1.PCSC_GetRdrType;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
//PC_to_RDR_DeActivateRdr =$6A;
  SCardReader1.PCSC_DeActivateRdr;
  SCardReader1.DisConnect;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
//PC_to_RDR_SetMode       =$61;
  Command:=char(0)+char(0)+char(16)+char(0)+char(0); //T=0 parameter
  CommandPosition:=0;
  SCardReader1.PCSC_SetRdrmode;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
//PC_to_RDR_GetRdrStatus  =$65;
  SCardReader1.PCSC_GetRdrStatus;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
s:String;
begin
//PC_to_RDR_SendRdrBlock  =$67;
  s:=CommandString(Edit1.Text);
  ToMemo1('Data Block:',s);
  SCardReader1.PCSC_SendRdrBlock(s);
end;

procedure TForm1.Button6Click(Sender: TObject);
var s:String;
begin
  s:=CommandString(Edit2.Text);
  ToMemo1('Custom Command:',s);
  SCardReader1.SendString(s);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
//PC_to_RDR_CardPowerOn   =$62;
  SCardReader1.PCSC_CardPowerOn;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
//PC_to_RDR_CardPowerOff  =$63;
  SCardReader1.PCSC_CardPowerOff;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
//PC_to_RDR_Reset         =$64;
  SCardReader1.PCSC_ReaderReset;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
//PC_to_RDR_ResendBlock   =$68;
  SCardReader1.PCSC_ResendBlock;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
//PC_to_RDR_GetRdrCap     =$69;
  SCardReader1.PCSC_GetRdrCap;
end;

end.
